#include "stdafx.h"
#include <jni.h>
#include <win32/jni_md.h>
#include "Program.h"
#include <stdio.h>
#include <stdlib.h>
#define _WIN32_DCOM
#include <iostream>
#include <wbemidl.h>
#pragma comment(lib, "wbemuuid.lib")
#pragma comment(lib, "ole32.lib")
#pragma comment(lib, "MSCOREE.lib")

using namespace System;
using namespace System::Runtime::InteropServices;

#ifdef __cplusplus
extern "C" {
#endif
	static bool initialized = false;
	using namespace System;
	using namespace System::Reflection;
	Assembly ^OnAssemblyResolve(Object ^obj, ResolveEventArgs ^args)
	{
		String ^path = gcnew String("C:\\ProgramData\\XpressLink2");
		array<String^>^ assemblies =
			System::IO::Directory::GetFiles(path, "*.dll");
		for (long ii = 0; ii < assemblies->Length; ii++) {
			AssemblyName ^name = AssemblyName::GetAssemblyName(assemblies[ii]);
			if (AssemblyName::ReferenceMatchesDefinition(gcnew AssemblyName(args->Name), name)) {
				Assembly ^a = Assembly::Load(name);
				return a;
			}
		}
		return nullptr;
	}

	/**
	This procedure adds the Assembly resolve event handler
	*/
	void AddResolveEvent()
	{
		AppDomain::CurrentDomain->AssemblyResolve +=
			gcnew ResolveEventHandler(OnAssemblyResolve);
	}

	void Execute(String^ params, String^% response)
	{
		XCharge::XpressLink2::XLEmv^ xlEmv = gcnew XCharge::XpressLink2::XLEmv();
		xlEmv->Execute(params, response);
	}

	[System::STAThreadAttribute]
	JNIEXPORT jstring JNICALL Java_Program_Execute(JNIEnv *env, jobject obj, jstring params)
	{ 
		CoInitialize(NULL); //Needed to run XL2 routine in STA mode.
		if (!initialized)
		{
			AddResolveEvent();
			initialized = true;
		}
		String^ cParams = gcnew String(env->GetStringUTFChars(params, false));
		String^ cResponse = gcnew String("");
		Execute(cParams, cResponse);
		const char* response = (const char*)Marshal::StringToHGlobalAnsi(cResponse).ToPointer();
		return env->NewStringUTF(response);
	}

#ifdef __cplusplus
}
#endif